=== pcc-cd/Makefile ===
ifneq ($(KERNELRELEASE),)

obj-m := pcc_acpi_cd.o

else

obj-m := pcc_acpi_cd.o

#KVER  := $(shell uname -r)
KVER  ?= $(shell uname -r)

KDIR := $(DESTDIR)/lib/modules/$(KVER)/build
MDIR := $(DESTDIR)/lib/modules/$(KVER)/kernel/drivers/acpi/
PWD := $(shell pwd)

default:
	$(MAKE) -C $(KDIR) SUBDIRS=$(PWD) modules

install:
	install -d $(MDIR)
	install -m 644 -c $(obj-m:.o=.ko) $(MDIR)
	depmod -a

clean:
	rm -rf *.mod.c *.o *.ko .tmp_versions .$(obj-m:.o=)*

endif
