=== debian/changelog ===
panasonic-hotkey-kernel-2.6.15 (2.6.15.25-2) dapper; urgency=low

  * rebuild against new kernel ABI (26)

 -- Jun Kobayashi <fm4j-kbys@asahi-net.or.jp>  Mon, 24 Jul 2006 09:36:09 +0900

panasonic-hotkey-kernel-2.6.15 (2.6.15.25-1) dapper; urgency=low

  * Initial Release.

 -- Jun Kobayashi <fm4j-kbys@asahi-net.or.jp>  Sat, 24 Jun 2006 17:41:14 +0900
