=== debian/control ===
# NOTE: THIS FILE IS AUTO-GENERATED FROM control.in
Source: panasonic-hotkey-kernel-2.6.15
Section: libs
Priority: optional
Maintainer: Jun Kobayashi <fm4j-kbys@asahi-net.or.jp>
Build-Depends: debhelper (>= 4.0.0), linux-headers-2.6.15-26-686 [i386], module-init-tools, sed (>> 3.0), bzip2
Standards-Version: 3.6.2

Package: panasonic-hotkey-kernel-source
Section: utils
Architecture: all
Depends: module-assistant, debhelper (>>4.0.0), make, bzip2
Description: Source for the panasonic-hotkey driver.
 This package provides the source code for the panasonic-hotkey kernel modules.
 The panasonic-hotkey package is also required in order to make use of these
 modules. Kernel source or headers are required to compile these modules.

Package: panasonic-hotkey-kernel-modules
Section: utils
Architecture: all
Depends: panasonic-hotkey-kernel-modules-2.6.15-26 | panasonic-hotkey-kernel-modules-custom
Description: panasonic-hotkey kernel module dependency package
 This empty package allows people to keep their panasonic-hotkey kernel
 modules up-to-date when upgrading their Linux kernel.

Package: panasonic-hotkey-kernel-modules-2.6.15-26
Architecture: i386
Priority: optional
Depends: module-init-tools
Recommends: ${linuximagerecommends}
Description: panasonic-hotkey modules for Linux (kernel 2.6.15)
 This package contains the set of loadable kernel modules for
 panasonic-hotkey.
 .
 This package contains the compiled kernel modules for 2.6.15.  All
 supported kernel types for this architecture are included in this single
 package.
 .
 If you have compiled your own kernel, you will most likely need to build
 your own panasonic-hotkey-kernel-modules. The panasonic-hotkey-kernel-source
 package has been provided for use with the Debian's module-assistant or
 kernel-package utilities to produce a version of panasonic-hotkey-kernel-module
 for your kernel.
